import {
  AKChart
} from "./chunk-5Q74C2I4.js";
import {
  EventGeo,
  EventUser
} from "./chunk-KQ2C2DZY.js";
import "./chunk-6BJ64FHW.js";
import {
  actionToLabel
} from "./chunk-JNMHWSG7.js";
import "./chunk-FNV26V2B.js";
import "./chunk-DJQHOO67.js";
import {
  TablePage
} from "./chunk-BOFJZWRL.js";
import "./chunk-JUOHD3PM.js";
import "./chunk-NRRZ6XDD.js";
import "./chunk-MXCYZZ7R.js";
import "./chunk-UX7TDHO2.js";
import "./chunk-F4SCNWUD.js";
import {
  card_default
} from "./chunk-ITYWTYEW.js";
import {
  TableColumn
} from "./chunk-KZUPUEAQ.js";
import "./chunk-K3AR7TXW.js";
import "./chunk-KP2VLRW5.js";
import "./chunk-EXVQ6V2P.js";
import {
  DEFAULT_CONFIG,
  EventsApi,
  getRelativeTime,
  n,
  t
} from "./chunk-AMC4UCMS.js";
import {
  i,
  ke,
  msg
} from "./chunk-XFT4DB4U.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// src/admin/events/EventVolumeChart.ts
var EventVolumeChart = class extends AKChart {
  set query(value) {
    this._query = value;
    this.refreshHandler();
  }
  static get styles() {
    return super.styles.concat(
      card_default,
      i`
                .pf-c-card__body {
                    height: 12rem;
                }
            `
    );
  }
  apiRequest() {
    return new EventsApi(DEFAULT_CONFIG).eventsEventsVolumeList(this._query);
  }
  getChartData(data) {
    return {
      datasets: [
        {
          label: msg("Events"),
          backgroundColor: "rgba(189, 229, 184, .5)",
          spanGaps: true,
          data: data.map((cord) => {
            return {
              x: cord.xCord || 0,
              y: cord.yCord || 0
            };
          }) || []
        }
      ]
    };
  }
  render() {
    return ke`<div class="pf-c-card">
            <div class="pf-c-card__title">${msg("Event volume")}</div>
            <div class="pf-c-card__body">${super.render()}</div>
        </div>`;
  }
};
__decorateClass([
  n({ attribute: false })
], EventVolumeChart.prototype, "query", 1);
EventVolumeChart = __decorateClass([
  t("ak-events-volume-chart")
], EventVolumeChart);

// src/admin/events/EventListPage.ts
var EventListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.expandable = true;
    this.order = "-created";
  }
  pageTitle() {
    return msg("Event Log");
  }
  pageDescription() {
    return;
  }
  pageIcon() {
    return "pf-icon pf-icon-catalog";
  }
  searchEnabled() {
    return true;
  }
  static get styles() {
    return super.styles.concat(i`
            .pf-m-no-padding-bottom {
                padding-bottom: 0;
            }
        `);
  }
  async apiEndpoint() {
    return new EventsApi(DEFAULT_CONFIG).eventsEventsList(await this.defaultEndpointConfig());
  }
  columns() {
    return [
      new TableColumn(msg("Action"), "action"),
      new TableColumn(msg("User"), "user"),
      new TableColumn(msg("Creation Date"), "created"),
      new TableColumn(msg("Client IP"), "client_ip"),
      new TableColumn(msg("Brand"), "brand_name"),
      new TableColumn(msg("Actions"))
    ];
  }
  renderSectionBefore() {
    return ke`
            <div class="pf-c-page__main-section pf-m-no-padding-bottom">
                <ak-events-volume-chart
                    .query=${{
      page: this.page,
      search: this.search
    }}
                ></ak-events-volume-chart>
            </div>
        `;
  }
  row(item) {
    return [
      ke`<div>${actionToLabel(item.action)}</div>
                <small>${item.app}</small>`,
      EventUser(item),
      ke`<div>${getRelativeTime(item.created)}</div>
                <small>${item.created.toLocaleString()}</small>`,
      ke`<div>${item.clientIp || msg("-")}</div>
                <small>${EventGeo(item)}</small>`,
      ke`<span>${item.brand?.name || msg("-")}</span>`,
      ke`<a href="#/events/log/${item.pk}">
                <pf-tooltip position="top" content=${msg("Show details")}>
                    <i class="fas fa-share-square"></i>
                </pf-tooltip>
            </a>`
    ];
  }
  renderExpanded(item) {
    return ke` <td role="cell" colspan="5">
                <div class="pf-c-table__expandable-row-content">
                    <ak-event-info .event=${item}></ak-event-info>
                </div>
            </td>
            <td></td>
            <td></td>
            <td></td>`;
  }
};
__decorateClass([
  n()
], EventListPage.prototype, "order", 2);
EventListPage = __decorateClass([
  t("ak-event-list")
], EventListPage);
export {
  EventListPage
};
//# sourceMappingURL=EventListPage-R7L4FX3E.js.map
