import "./chunk-GXGHOOOB.js";
import {
  StagesApi
} from "./chunk-RGOIMBH4.js";
import "./chunk-UOXFC4Y2.js";
import "./chunk-WKHTTNZV.js";
import "./chunk-6P4Q5A35.js";
import "./chunk-YHBCGAQD.js";
import {
  RbacPermissionsAssignedByUsersListModelEnum
} from "./chunk-KAZHUE5U.js";
import "./chunk-RRTO23J6.js";
import "./chunk-WJSRKCWV.js";
import {
  TablePage
} from "./chunk-BOFJZWRL.js";
import "./chunk-3JQUPLLV.js";
import "./chunk-LC5NTBIM.js";
import "./chunk-W4FPXHKC.js";
import "./chunk-73PMFTGI.js";
import "./chunk-OBKOQLSR.js";
import "./chunk-O6PXCBWL.js";
import "./chunk-AYF4HFW2.js";
import "./chunk-WUMYQQVB.js";
import "./chunk-JDNU6LE7.js";
import "./chunk-MN6O4CLE.js";
import "./chunk-MXCYZZ7R.js";
import "./chunk-UX7TDHO2.js";
import "./chunk-LQRAB2DN.js";
import "./chunk-XCEM2TDB.js";
import "./chunk-F4SCNWUD.js";
import "./chunk-ITYWTYEW.js";
import "./chunk-O4CYWEUV.js";
import {
  TableColumn
} from "./chunk-KZUPUEAQ.js";
import "./chunk-K3AR7TXW.js";
import "./chunk-KP2VLRW5.js";
import "./chunk-EXVQ6V2P.js";
import {
  DEFAULT_CONFIG,
  n,
  t
} from "./chunk-AMC4UCMS.js";
import {
  ke,
  msg
} from "./chunk-XFT4DB4U.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// src/admin/stages/prompt/PromptListPage.ts
var PromptListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "name";
  }
  searchEnabled() {
    return true;
  }
  pageTitle() {
    return msg("Prompts");
  }
  pageDescription() {
    return msg("Single Prompts that can be used for Prompt Stages.");
  }
  pageIcon() {
    return "pf-icon pf-icon-plugged";
  }
  async apiEndpoint() {
    return new StagesApi(DEFAULT_CONFIG).stagesPromptPromptsList(
      await this.defaultEndpointConfig()
    );
  }
  columns() {
    return [
      new TableColumn(msg("Name"), "name"),
      new TableColumn(msg("Field"), "field_key"),
      new TableColumn(msg("Type"), "type"),
      new TableColumn(msg("Order"), "order"),
      new TableColumn(msg("Stages")),
      new TableColumn(msg("Actions"))
    ];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return ke`<ak-forms-delete-bulk
            objectLabel=${msg("Prompt(s)")}
            .objects=${this.selectedElements}
            .usedBy=${(item) => {
      return new StagesApi(DEFAULT_CONFIG).stagesPromptPromptsUsedByList({
        promptUuid: item.pk
      });
    }}
            .delete=${(item) => {
      return new StagesApi(DEFAULT_CONFIG).stagesPromptPromptsDestroy({
        promptUuid: item.pk
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  row(item) {
    return [
      ke`${item.name}`,
      ke`<code>${item.fieldKey}</code>`,
      ke`${item.type}`,
      ke`${item.order}`,
      ke`${item.promptstageSet?.map((stage) => {
        return ke`<li>${stage.name}</li>`;
      })}`,
      ke`<ak-forms-modal size=${"pf-m-xl" /* XLarge */}>
                    <span slot="submit"> ${msg("Update")} </span>
                    <span slot="header"> ${msg("Update Prompt")} </span>
                    <ak-prompt-form slot="form" .instancePk=${item.pk}> </ak-prompt-form>
                    <button slot="trigger" class="pf-c-button pf-m-plain">
                        <pf-tooltip position="top" content=${msg("Edit")}>
                            <i class="fas fa-edit"></i>
                        </pf-tooltip>
                    </button>
                </ak-forms-modal>
                <ak-rbac-object-permission-modal
                    model=${RbacPermissionsAssignedByUsersListModelEnum.StagesPromptPrompt}
                    objectPk=${item.pk}
                >
                </ak-rbac-object-permission-modal> `
    ];
  }
  renderObjectCreate() {
    return ke`
            <ak-forms-modal size=${"pf-m-xl" /* XLarge */}>
                <span slot="submit"> ${msg("Create")} </span>
                <span slot="header"> ${msg("Create Prompt")} </span>
                <ak-prompt-form slot="form"> </ak-prompt-form>
                <button slot="trigger" class="pf-c-button pf-m-primary">${msg("Create")}</button>
            </ak-forms-modal>
        `;
  }
};
__decorateClass([
  n()
], PromptListPage.prototype, "order", 2);
PromptListPage = __decorateClass([
  t("ak-stage-prompt-list")
], PromptListPage);
export {
  PromptListPage
};
//# sourceMappingURL=PromptListPage-3QUO5VTH.js.map
