import "./chunk-QVNDK2YP.js";
import "./chunk-TF7DSUKN.js";
import "./chunk-UU3EFNVH.js";
import "./chunk-DBE2FDDV.js";
import "./chunk-OHFV76U2.js";
import {
  TablePage
} from "./chunk-BOFJZWRL.js";
import "./chunk-TE2OYAEB.js";
import "./chunk-6D56GHTB.js";
import "./chunk-33FVPXQF.js";
import "./chunk-I563NQZY.js";
import "./chunk-7YOZYTPC.js";
import "./chunk-XOIODRMJ.js";
import "./chunk-3JQUPLLV.js";
import "./chunk-LC5NTBIM.js";
import "./chunk-VPULNDE4.js";
import "./chunk-PYFMVSMA.js";
import "./chunk-H6O674E7.js";
import "./chunk-VQLEOAO7.js";
import "./chunk-ACKAU7UB.js";
import "./chunk-LEBYUIHG.js";
import "./chunk-ILUJ2G4Q.js";
import "./chunk-6CHAI4AU.js";
import "./chunk-7FLGQNJB.js";
import "./chunk-QSUYMBXD.js";
import "./chunk-T7CHIH4E.js";
import "./chunk-J6R4SJRI.js";
import "./chunk-W4FPXHKC.js";
import "./chunk-73PMFTGI.js";
import "./chunk-OBKOQLSR.js";
import "./chunk-O6PXCBWL.js";
import "./chunk-AYF4HFW2.js";
import {
  Form
} from "./chunk-WUMYQQVB.js";
import "./chunk-ENUGJATC.js";
import {
  ProvidersApi
} from "./chunk-VREDFYGR.js";
import "./chunk-CDWXKNE6.js";
import "./chunk-JDNU6LE7.js";
import "./chunk-GNYEGOJX.js";
import "./chunk-647BK4MP.js";
import "./chunk-BJ44WOI4.js";
import {
  FlowsInstancesListDesignationEnum
} from "./chunk-JUOHD3PM.js";
import "./chunk-NRRZ6XDD.js";
import "./chunk-MN6O4CLE.js";
import "./chunk-MXCYZZ7R.js";
import "./chunk-UX7TDHO2.js";
import "./chunk-LQRAB2DN.js";
import "./chunk-XCEM2TDB.js";
import "./chunk-F4SCNWUD.js";
import "./chunk-ITYWTYEW.js";
import "./chunk-VRCRCQLD.js";
import "./chunk-EEANTJCZ.js";
import "./chunk-O4CYWEUV.js";
import {
  TableColumn
} from "./chunk-KZUPUEAQ.js";
import "./chunk-K3AR7TXW.js";
import "./chunk-KP2VLRW5.js";
import "./chunk-EXVQ6V2P.js";
import {
  AKElement,
  DEFAULT_CONFIG,
  SentryIgnoredError,
  button_default,
  e,
  n,
  patternfly_base_default,
  t
} from "./chunk-AMC4UCMS.js";
import {
  ke,
  msg,
  str
} from "./chunk-XFT4DB4U.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// src/admin/providers/saml/SAMLProviderImportForm.ts
var SAMLProviderImportForm = class extends Form {
  getSuccessMessage() {
    return msg("Successfully imported provider.");
  }
  async send(data) {
    const file = this.getFormFiles()["metadata"];
    if (!file) {
      throw new SentryIgnoredError("No form data");
    }
    return new ProvidersApi(DEFAULT_CONFIG).providersSamlImportMetadataCreate({
      file,
      name: data.name,
      authorizationFlow: data.authorizationFlow || ""
    });
  }
  renderForm() {
    return ke`<ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input type="text" class="pf-c-form-control" required />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Authorization flow")}
                ?required=${true}
                name="authorizationFlow"
            >
                <ak-flow-search-no-default
                    flowType=${FlowsInstancesListDesignationEnum.Authorization}
                    required
                ></ak-flow-search-no-default>
                <p class="pf-c-form__helper-text">
                    ${msg("Flow used when authorizing this provider.")}
                </p>
            </ak-form-element-horizontal>

            <ak-form-element-horizontal label=${msg("Metadata")} name="metadata">
                <input type="file" value="" class="pf-c-form-control" />
            </ak-form-element-horizontal>`;
  }
};
SAMLProviderImportForm = __decorateClass([
  t("ak-provider-saml-import-form")
], SAMLProviderImportForm);

// src/admin/providers/ProviderWizard.ts
var ProviderWizard = class extends AKElement {
  constructor() {
    super(...arguments);
    this.createText = msg("Create");
    this.providerTypes = [];
    this.finalHandler = () => {
      return Promise.resolve();
    };
  }
  static get styles() {
    return [patternfly_base_default, button_default];
  }
  async firstUpdated() {
    this.providerTypes = await new ProvidersApi(DEFAULT_CONFIG).providersAllTypesList();
  }
  render() {
    return ke`
            <ak-wizard
                .steps=${["initial"]}
                header=${msg("New provider")}
                description=${msg("Create a new provider.")}
                .finalHandler=${() => {
      return this.finalHandler();
    }}
            >
                <ak-wizard-page-type-create
                    slot="initial"
                    layout=${"grid" /* grid */}
                    .types=${this.providerTypes}
                    @select=${(ev) => {
      if (!this.wizard) return;
      this.wizard.steps = ["initial", `type-${ev.detail.component}`];
      this.wizard.isValid = true;
    }}
                >
                </ak-wizard-page-type-create>
                ${this.providerTypes.map((type) => {
      return ke`
                        <ak-wizard-page-form
                            slot=${`type-${type.component}`}
                            .sidebarLabel=${() => msg(str`Create ${type.name}`)}
                        >
                            <ak-proxy-form type=${type.component}></ak-proxy-form>
                        </ak-wizard-page-form>
                    `;
    })}
                <button slot="trigger" class="pf-c-button pf-m-primary">${this.createText}</button>
            </ak-wizard>
        `;
  }
};
__decorateClass([
  n()
], ProviderWizard.prototype, "createText", 2);
__decorateClass([
  n({ attribute: false })
], ProviderWizard.prototype, "providerTypes", 2);
__decorateClass([
  n({ attribute: false })
], ProviderWizard.prototype, "finalHandler", 2);
__decorateClass([
  e("ak-wizard")
], ProviderWizard.prototype, "wizard", 2);
ProviderWizard = __decorateClass([
  t("ak-provider-wizard")
], ProviderWizard);

// src/admin/providers/ProviderListPage.ts
var ProviderListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "name";
  }
  searchEnabled() {
    return true;
  }
  pageTitle() {
    return msg("Providers");
  }
  pageDescription() {
    return msg("Provide support for protocols like SAML and OAuth to assigned applications.");
  }
  pageIcon() {
    return "pf-icon pf-icon-integration";
  }
  async apiEndpoint() {
    return new ProvidersApi(DEFAULT_CONFIG).providersAllList(
      await this.defaultEndpointConfig()
    );
  }
  columns() {
    return [
      new TableColumn(msg("Name"), "name"),
      new TableColumn(msg("Application")),
      new TableColumn(msg("Type")),
      new TableColumn(msg("Actions"))
    ];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return ke`<ak-forms-delete-bulk
            objectLabel=${msg("Provider(s)")}
            .objects=${this.selectedElements}
            .usedBy=${(item) => {
      return new ProvidersApi(DEFAULT_CONFIG).providersAllUsedByList({
        id: item.pk
      });
    }}
            .delete=${(item) => {
      return new ProvidersApi(DEFAULT_CONFIG).providersAllDestroy({
        id: item.pk
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  rowApp(item) {
    if (item.assignedApplicationName) {
      return ke`<i class="pf-icon pf-icon-ok pf-m-success"></i>
                ${msg("Assigned to application ")}
                <a href="#/core/applications/${item.assignedApplicationSlug}"
                    >${item.assignedApplicationName}</a
                >`;
    }
    if (item.assignedBackchannelApplicationName) {
      return ke`<i class="pf-icon pf-icon-ok pf-m-success"></i>
                ${msg("Assigned to application (backchannel) ")}
                <a href="#/core/applications/${item.assignedBackchannelApplicationSlug}"
                    >${item.assignedBackchannelApplicationName}</a
                >`;
    }
    return ke`<i class="pf-icon pf-icon-warning-triangle pf-m-warning"></i> ${msg(
      "Warning: Provider not assigned to any application."
    )}`;
  }
  row(item) {
    return [
      ke`<a href="#/core/providers/${item.pk}"> ${item.name} </a>`,
      this.rowApp(item),
      ke`${item.verboseName}`,
      ke`<ak-forms-modal>
                <span slot="submit"> ${msg("Update")} </span>
                <span slot="header"> ${msg(str`Update ${item.verboseName}`)} </span>
                <ak-proxy-form
                    slot="form"
                    .args=${{
        instancePk: item.pk
      }}
                    type=${item.component}
                >
                </ak-proxy-form>
                <button slot="trigger" class="pf-c-button pf-m-plain">
                    <pf-tooltip position="top" content=${msg("Edit")}>
                        <i class="fas fa-edit"></i>
                    </pf-tooltip>
                </button>
            </ak-forms-modal>`
    ];
  }
  renderObjectCreate() {
    return ke`<ak-provider-wizard> </ak-provider-wizard> `;
  }
};
__decorateClass([
  n()
], ProviderListPage.prototype, "order", 2);
ProviderListPage = __decorateClass([
  t("ak-provider-list")
], ProviderListPage);
export {
  ProviderListPage
};
//# sourceMappingURL=ProviderListPage-QEVDPBXN.js.map
