import {
  getCountryFlag
} from "./chunk-7PVVYFAP.js";
import "./chunk-6P4Q5A35.js";
import {
  PoliciesApi
} from "./chunk-HF2QJKVK.js";
import "./chunk-YHBCGAQD.js";
import {
  RbacPermissionsAssignedByUsersListModelEnum
} from "./chunk-KAZHUE5U.js";
import "./chunk-RRTO23J6.js";
import "./chunk-WJSRKCWV.js";
import {
  TablePage
} from "./chunk-BOFJZWRL.js";
import "./chunk-3JQUPLLV.js";
import "./chunk-LC5NTBIM.js";
import "./chunk-73PMFTGI.js";
import "./chunk-O6PXCBWL.js";
import "./chunk-AYF4HFW2.js";
import "./chunk-WUMYQQVB.js";
import "./chunk-NRRZ6XDD.js";
import "./chunk-UX7TDHO2.js";
import "./chunk-LQRAB2DN.js";
import "./chunk-XCEM2TDB.js";
import "./chunk-F4SCNWUD.js";
import "./chunk-ITYWTYEW.js";
import "./chunk-O4CYWEUV.js";
import {
  TableColumn
} from "./chunk-KZUPUEAQ.js";
import "./chunk-K3AR7TXW.js";
import "./chunk-KP2VLRW5.js";
import "./chunk-EXVQ6V2P.js";
import {
  DEFAULT_CONFIG,
  getRelativeTime,
  n,
  t
} from "./chunk-AMC4UCMS.js";
import {
  ke,
  msg
} from "./chunk-XFT4DB4U.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// src/admin/policies/reputation/ReputationListPage.ts
var ReputationListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.order = "identifier";
    this.checkbox = true;
    this.clearOnRefresh = true;
  }
  searchEnabled() {
    return true;
  }
  pageTitle() {
    return msg("Reputation scores");
  }
  pageDescription() {
    return msg(
      "Reputation for IP and user identifiers. Scores are decreased for each failed login and increased for each successful login."
    );
  }
  pageIcon() {
    return "fa fa-ban";
  }
  async apiEndpoint() {
    return new PoliciesApi(DEFAULT_CONFIG).policiesReputationScoresList({
      ...await this.defaultEndpointConfig()
    });
  }
  columns() {
    return [
      new TableColumn(msg("Identifier"), "identifier"),
      new TableColumn(msg("IP"), "ip"),
      new TableColumn(msg("Score"), "score"),
      new TableColumn(msg("Updated"), "updated"),
      new TableColumn(msg("Actions"))
    ];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return ke`<ak-forms-delete-bulk
            objectLabel=${msg("Reputation")}
            .objects=${this.selectedElements}
            .usedBy=${(item) => {
      return new PoliciesApi(DEFAULT_CONFIG).policiesReputationScoresUsedByList({
        reputationUuid: item.pk || ""
      });
    }}
            .delete=${(item) => {
      return new PoliciesApi(DEFAULT_CONFIG).policiesReputationScoresDestroy({
        reputationUuid: item.pk || ""
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  row(item) {
    return [
      ke`${item.identifier}`,
      ke`${item.ipGeoData?.country ? ke` ${getCountryFlag(item.ipGeoData.country)} ` : ke``}
            ${item.ip}`,
      ke`${item.score}`,
      ke`<div>${getRelativeTime(item.updated)}</div>
                <small>${item.updated.toLocaleString()}</small>`,
      ke`
                <ak-rbac-object-permission-modal
                    model=${RbacPermissionsAssignedByUsersListModelEnum.PoliciesReputationReputationpolicy}
                    objectPk=${item.pk || ""}
                >
                </ak-rbac-object-permission-modal>
            `
    ];
  }
};
__decorateClass([
  n()
], ReputationListPage.prototype, "order", 2);
ReputationListPage = __decorateClass([
  t("ak-policy-reputation-list")
], ReputationListPage);
export {
  ReputationListPage
};
//# sourceMappingURL=ReputationListPage-QWJT4QU2.js.map
