import "./chunk-SO7CG2U7.js";
import "./chunk-CIXDH6YJ.js";
import "./chunk-TF7DSUKN.js";
import "./chunk-OHFV76U2.js";
import {
  TablePage
} from "./chunk-BOFJZWRL.js";
import "./chunk-VPULNDE4.js";
import "./chunk-PYFMVSMA.js";
import "./chunk-H6O674E7.js";
import "./chunk-VQLEOAO7.js";
import "./chunk-ACKAU7UB.js";
import "./chunk-LEBYUIHG.js";
import "./chunk-ILUJ2G4Q.js";
import "./chunk-6CHAI4AU.js";
import "./chunk-7FLGQNJB.js";
import "./chunk-QSUYMBXD.js";
import "./chunk-T7CHIH4E.js";
import "./chunk-J6R4SJRI.js";
import "./chunk-W4FPXHKC.js";
import "./chunk-73PMFTGI.js";
import "./chunk-OBKOQLSR.js";
import "./chunk-O6PXCBWL.js";
import "./chunk-AYF4HFW2.js";
import "./chunk-WUMYQQVB.js";
import {
  SourcesApi
} from "./chunk-CDWXKNE6.js";
import "./chunk-JDNU6LE7.js";
import "./chunk-GNYEGOJX.js";
import "./chunk-647BK4MP.js";
import "./chunk-BJ44WOI4.js";
import "./chunk-JUOHD3PM.js";
import "./chunk-NRRZ6XDD.js";
import "./chunk-MN6O4CLE.js";
import "./chunk-MXCYZZ7R.js";
import "./chunk-UX7TDHO2.js";
import "./chunk-LQRAB2DN.js";
import "./chunk-XCEM2TDB.js";
import "./chunk-F4SCNWUD.js";
import "./chunk-ITYWTYEW.js";
import "./chunk-EEANTJCZ.js";
import "./chunk-O4CYWEUV.js";
import {
  TableColumn
} from "./chunk-KZUPUEAQ.js";
import "./chunk-K3AR7TXW.js";
import {
  to
} from "./chunk-KP2VLRW5.js";
import "./chunk-EXVQ6V2P.js";
import {
  AKElement,
  DEFAULT_CONFIG,
  button_default,
  e,
  n,
  patternfly_base_default,
  t
} from "./chunk-AMC4UCMS.js";
import {
  ke,
  msg,
  str
} from "./chunk-XFT4DB4U.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// src/admin/sources/SourceWizard.ts
var SourceWizard = class extends AKElement {
  constructor() {
    super(...arguments);
    this.sourceTypes = [];
  }
  static get styles() {
    return [patternfly_base_default, button_default];
  }
  firstUpdated() {
    new SourcesApi(DEFAULT_CONFIG).sourcesAllTypesList().then((types) => {
      this.sourceTypes = types;
    });
  }
  render() {
    return ke`
            <ak-wizard
                .steps=${["initial"]}
                header=${msg("New source")}
                description=${msg("Create a new source.")}
            >
                <ak-wizard-page-type-create
                    slot="initial"
                    .types=${this.sourceTypes}
                    layout=${"grid" /* grid */}
                    @select=${(ev) => {
      if (!this.wizard) return;
      this.wizard.steps = [
        "initial",
        `type-${ev.detail.component}-${ev.detail.modelName}`
      ];
      this.wizard.isValid = true;
    }}
                >
                </ak-wizard-page-type-create>
                ${this.sourceTypes.map((type) => {
      return ke`
                        <ak-wizard-page-form
                            slot=${`type-${type.component}-${type.modelName}`}
                            .sidebarLabel=${() => msg(str`Create ${type.name}`)}
                        >
                            <ak-proxy-form
                                .args=${{
        modelName: type.modelName
      }}
                                type=${type.component}
                            ></ak-proxy-form>
                        </ak-wizard-page-form>
                    `;
    })}
                <button slot="trigger" class="pf-c-button pf-m-primary">${msg("Create")}</button>
            </ak-wizard>
        `;
  }
};
__decorateClass([
  n({ attribute: false })
], SourceWizard.prototype, "sourceTypes", 2);
__decorateClass([
  e("ak-wizard")
], SourceWizard.prototype, "wizard", 2);
SourceWizard = __decorateClass([
  t("ak-source-wizard")
], SourceWizard);

// src/admin/sources/SourceListPage.ts
var SourceListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "name";
  }
  pageTitle() {
    return msg("Federation and Social login");
  }
  pageDescription() {
    return msg(
      "Sources of identities, which can either be synced into authentik's database, or can be used by users to authenticate and enroll themselves."
    );
  }
  pageIcon() {
    return "pf-icon pf-icon-middleware";
  }
  searchEnabled() {
    return true;
  }
  async apiEndpoint() {
    return new SourcesApi(DEFAULT_CONFIG).sourcesAllList(await this.defaultEndpointConfig());
  }
  columns() {
    return [
      new TableColumn(msg("Name"), "name"),
      new TableColumn(msg("Type")),
      new TableColumn("")
    ];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return ke`<ak-forms-delete-bulk
            objectLabel=${msg("Source(s)")}
            .objects=${this.selectedElements}
            .usedBy=${(item) => {
      return new SourcesApi(DEFAULT_CONFIG).sourcesAllUsedByList({
        slug: item.slug
      });
    }}
            .delete=${(item) => {
      return new SourcesApi(DEFAULT_CONFIG).sourcesAllDestroy({
        slug: item.slug
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  row(item) {
    if (item.component === "") {
      return this.rowInbuilt(item);
    }
    return [
      ke`<a href="#/core/sources/${item.slug}">
                <div>${item.name}</div>
                ${item.enabled ? ke`` : ke`<ak-label color=${"pf-m-orange" /* Orange */} ?compact=${true}>
                          ${msg("Disabled")}</ak-label
                      >`}
            </a>`,
      ke`${item.verboseName}`,
      ke` <ak-forms-modal>
                <span slot="submit"> ${msg("Update")} </span>
                <span slot="header"> ${msg(str`Update ${item.verboseName}`)} </span>
                <ak-proxy-form
                    slot="form"
                    .args=${{
        instancePk: item.slug
      }}
                    type=${to(item.component)}
                >
                </ak-proxy-form>
                <button slot="trigger" class="pf-c-button pf-m-plain">
                    <pf-tooltip position="top" content=${msg("Edit")}>
                        <i class="fas fa-edit"></i>
                    </pf-tooltip>
                </button>
            </ak-forms-modal>`
    ];
  }
  rowInbuilt(item) {
    return [
      ke`<div>
                <div>${item.name}</div>
                <ak-label color=${"" /* Grey */} ?compact=${true}> ${msg("Built-in")}</ak-label>
            </div>`,
      ke`${msg("Built-in")}`,
      ke``
    ];
  }
  renderObjectCreate() {
    return ke`<ak-source-wizard> </ak-source-wizard> `;
  }
};
__decorateClass([
  n()
], SourceListPage.prototype, "order", 2);
SourceListPage = __decorateClass([
  t("ak-source-list")
], SourceListPage);
export {
  SourceListPage
};
//# sourceMappingURL=SourceListPage-QR7DSOGC.js.map
